//
// SHDesignes CoExec library version 1.4
//
// Copyright 2006-2008 SHDesigns
//
// This code can be used freely and with no cost. The source can not
// be sold without permission from SHDesigns.
//
// please consider donating to support this project
// donations can be made via paypal to rabbit@shdesigns.org

// this must be defined to use the lib. If event support needs to be disabled
// comment out this line and recompile the library.
#define USE_EVENTS

//
// macros to emulate some Dynamic C
//
#define yield task_switch()
#define wfd
#define waitfordone
#define waitfor(x)  while (!(x)) yield
#define cofunc
#define scofunc

#define F_NULL ((void far *)0l)

#define TASK_RUNNING 0x7FFF
#define TASK_ABORT -32768 // use this return value if chk_abort() says exit

#define DELAY_OFF 8
#define DELAY_START_OFF 12
#define STACK_OFF 0
#define RUN_OFF 16
#define SSEG_OFF 18

typedef struct _task {
    unsigned *  stack;
    unsigned *  stack_start;
    unsigned    stack_size;
    int (*task)(int);
    unsigned long delay;    // wait delay time
    unsigned long delay_start;
    char run;
    char abort;
#ifdef FAR_STACKS
	char sseg;
#endif
	char * event;
    int exit;   // must be last entry, used for sizeof()
} TASK;

typedef struct _task_stack {
#ifdef SAVE_ALL
	unsigned regs[10];
#else
	unsigned regs[2];
#endif
	unsigned char IP;
	void near (*stub)(int (*task)(),int param);
	unsigned char XPC;
	unsigned IX; // used in stub
    int (*func)(int);
  	int	param;
    unsigned task_num;
} TASK_STACK;

#define NO_DEBUG_PARSE // for udpdebug

extern unsigned char task_count;  // first task is always present
extern TASK tasks[];
extern TASK * _cur_task;

// initialization
#ifdef FAR_STACKS
int init_tasks(int num_t,long fstacksize);
#else
void init_tasks(int num_t);
#endif
int create_task(int (* func)(int),void * stack,unsigned stack_size,int param);
// task switching
void sleep(unsigned long stime);
void _nearcall task_switch(void);
// task start/stop
void task_run(int tasknum,int run);
// task abort/restart
void task_abort(int tasknum);
int restart_task(int tasknum, int param);
int near check_abort(void);
int check_exit(int task_num);  // return task exit value or TASK_RUNNING if still running
// stack ckecking
int check_stack(int tasknum);

// event routines, events are char flags passed by address
// wait for an event to be set
// returns state of event (1 if set, 0 if max_time reached)
int wait_event(char * eventflag,unsigned long max_time);

// set event and put tasks waiting in run state
// returns number of tasks waiting
int set_event(char * eventflag);

// clear an event
void clr_event(char * eventflag);



